/*
 * Copyright ETH 2017 - 2023 Zürich, Scientific IT Services
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ch.ethz.sis.openbis.generic.asapi.v3.dto.entitytype.update;

import java.util.List;

import ch.ethz.sis.openbis.generic.asapi.v3.dto.common.update.FieldUpdateValue;
import ch.ethz.sis.openbis.generic.asapi.v3.dto.common.update.IObjectUpdate;
import ch.ethz.sis.openbis.generic.asapi.v3.dto.common.update.IUpdate;
import ch.ethz.sis.openbis.generic.asapi.v3.dto.common.update.ListUpdateValue.ListUpdateAction;
import ch.ethz.sis.openbis.generic.asapi.v3.dto.entitytype.id.IEntityTypeId;
import ch.ethz.sis.openbis.generic.asapi.v3.dto.plugin.id.IPluginId;
import ch.systemsx.cisd.base.annotation.JsonObject;

/**
 * 
 *
 * @author Franz-Josef Elmer
 */
@JsonObject("as.dto.entitytype.update.IEntityTypeUpdate")
public interface IEntityTypeUpdate extends IUpdate, IObjectUpdate<IEntityTypeId>
{
    public IEntityTypeId getTypeId();

    public void setTypeId(IEntityTypeId typeId);

    public FieldUpdateValue<String> getDescription();

    public void setDescription(String description);

    public FieldUpdateValue<IPluginId> getValidationPluginId();

    public void setValidationPluginId(IPluginId pluginId);

    public PropertyAssignmentListUpdateValue getPropertyAssignments();
    
    public void setPropertyAssignmentActions(List<ListUpdateAction<Object>> actions);
}
